<?php

/**
 * DokuWiki farm oriented preloader
 *
 * @license    GPL 2 (http://www.gnu.org/licenses/gpl.html)
 * @author     Etienne MELEARD <etienne.meleard AT renater.fr>
 */

// Config section

define('DOKU_FARM_ROOT', '/var/www/wikifarm/');
define('DOKU_FARM_BARN', DOKU_FARM_ROOT.'barn/');
define('DOKU_FARM_MULTIHOSTING', true);


// /!\ /!\ /!\ /!\ /!\ /!\ /!\ /!\ /!\ /!\ /!\ /!\ /!\ /!\ /!\ /!\ /!\ /!\ /!\
// /!\                                                                     /!\
// /!\  Do not alter after this point unless you know what you are doing   /!\
// /!\                                                                     /!\
// /!\ /!\ /!\ /!\ /!\ /!\ /!\ /!\ /!\ /!\ /!\ /!\ /!\ /!\ /!\ /!\ /!\ /!\ /!\

if(!DOKU_FARM_ROOT || !@is_dir(DOKU_FARM_ROOT)) die('You must set the DOKU_FARM_ROOT constant in '.__FILE__.' in order for the wiki farm to work');
if(!DOKU_FARM_BARN || !@is_dir(DOKU_FARM_BARN)) die('You must set the DOKU_FARM_BARN constant in '.__FILE__.' in order for the wiki farm to work');

if(!defined('DOKU_FARM_MULTIHOSTING')) define('DOKU_FARM_MULTIHOSTING', false);

$host = $_SERVER['SERVER_NAME'];
$bits = array_values(array_filter(explode('/', $_SERVER['REQUEST_URI'])));
$id = (count($bits) > 1) ? $bits[1] : null;
if($id == '_farmer_') $id = null;

$animal_id = null;
if($host && $id) $animal_id = (DOKU_FARM_MULTIHOSTING ? $host.'/' : '').$id;
if(!@is_dir(DOKU_FARM_BARN.$animal_id)) $animal_id = null;

define('DOKU_FARM_ANIMAL_ID', $animal_id);
define('DOKU_FARM_IS_FARMER', !(bool)$animal_id);

define('DOKU_FARM_HOST', preg_replace('`\:[0-9]+$`', '', $_SERVER['SERVER_NAME']));

define('DOKU_FARM_BASEPATH', $animal_id ? DOKU_FARM_BARN.$animal_id.'/' : DOKU_INC);
define('DOKU_FARM_BASEURL', 'https://'.$_SERVER['SERVER_NAME'].'/');
define('DOKU_FARM_BASEDIR', '/wiki/'.($animal_id ? $id : '_farmer_').'/');

define('DOKU_DEFAULT', DOKU_INC.'conf/');
define('DOKU_CONF', DOKU_FARM_BASEPATH.'conf/');

$plugin_protected = array(DOKU_DEFAULT.'plugins.required.php');
if($animal_id) $plugin_protected[] = DOKU_DEFAULT.'plugins.barn.protected.php';

$conf_protected = array(DOKU_DEFAULT.'farm.protected.php');
if($animal_id) $conf_protected[] = DOKU_DEFAULT.'barn.protected.php';

$conf_protected[] = DOKU_CONF.'protected.php';

global $config_cascade;
$config_cascade = array(
    'main' => array(
        'default'   => array(DOKU_DEFAULT.'dokuwiki.php'),
        'local'     => array(DOKU_CONF.'local.php'),
        'protected' => $conf_protected,
    ),
    'acronyms'  => array(
        'default'   => array(DOKU_DEFAULT.'acronyms.conf'),
        'local'     => array(DOKU_CONF.'acronyms.conf'),
    ),
    'entities'  => array(
        'default'   => array(DOKU_DEFAULT.'entities.conf'),
        'local'     => array(DOKU_CONF.'entities.conf'),
    ),
    'interwiki' => array(
        'default'   => array(DOKU_DEFAULT.'interwiki.conf'),
        'local'     => array(DOKU_CONF.'interwiki.conf'),
    ),
    'license' => array(
        'default'   => array(DOKU_DEFAULT.'license.php'),
        'local'     => array(DOKU_CONF.'license.php'),
    ),
    'mediameta' => array(
        'default'   => array(DOKU_DEFAULT.'mediameta.php'),
        'local'     => array(DOKU_CONF.'mediameta.php'),
    ),
    'mime'      => array(
        'default'   => array(DOKU_DEFAULT.'mime.conf'),
        'local'     => array(DOKU_CONF.'mime.conf'),
    ),
    'scheme'    => array(
        'default'   => array(DOKU_DEFAULT.'scheme.conf'),
        'local'     => array(DOKU_CONF.'scheme.conf'),
    ),
    'smileys'   => array(
        'default'   => array(DOKU_DEFAULT.'smileys.conf'),
        'local'     => array(DOKU_CONF.'smileys.conf'),
    ),
    'wordblock' => array(
        'default'   => array(DOKU_DEFAULT.'wordblock.conf'),
        'local'     => array(DOKU_CONF.'wordblock.conf'),
    ),
    'acl'       => array(
        'default'   => DOKU_CONF.'acl.auth.php',
    ),
    'plainauth.users' => array(
        'default'   => DOKU_CONF.'users.auth.php',
    ),
    'plugins' => array(
        'local'     => array(DOKU_CONF.'plugins.local.php'),
        'protected' => $plugin_protected,
    ),
    'userstyle' => array(
        'default' => DOKU_CONF.'userstyle.css',
        'print'   => DOKU_CONF.'printstyle.css',
        'feed'    => DOKU_CONF.'feedstyle.css',
        'all'     => DOKU_CONF.'allstyle.css',
    ),
    'userscript' => array(
        'default' => DOKU_CONF.'userscript.js'
    ),
);
